package dev.shadowsoffire.apotheosis.ench.anvil;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.advancements.AdvancementTriggers;
import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.ench.anvil.AnvilTile;
import dev.shadowsoffire.apotheosis.util.INBTSensitiveFallingBlock;
import it.unimi.dsi.fastutil.objects.Object2IntMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import net.minecraft.ChatFormatting;
import net.minecraft.core.BlockPos;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.ListTag;
import net.minecraft.nbt.Tag;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.util.RandomSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntitySelector;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.item.FallingBlockEntity;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.EnchantedBookItem;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.world.item.enchantment.EnchantmentInstance;
import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.AnvilBlock;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.EntityBlock;
import net.minecraft.world.level.block.SoundType;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.material.MapColor;
import net.minecraft.world.level.material.PushReaction;
import net.minecraft.world.level.storage.loot.LootParams;
import net.minecraft.world.level.storage.loot.parameters.LootContextParams;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.phys.HitResult;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.registries.ForgeRegistries;

public class ApothAnvilBlock extends AnvilBlock implements INBTSensitiveFallingBlock, EntityBlock {
  public ApothAnvilBlock() {
    super(BlockBehaviour.Properties.m_284310_().m_284180_(MapColor.f_283906_).m_278166_(PushReaction.BLOCK).m_60999_().m_60913_(5.0F, 1200.0F).m_60918_(SoundType.f_56749_));
  }
  
  public BlockEntity m_142194_(BlockPos pPos, BlockState pState) {
    return (BlockEntity)new AnvilTile(pPos, pState);
  }
  
  public void m_6402_(Level world, BlockPos pos, BlockState state, LivingEntity placer, ItemStack stack) {
    BlockEntity te = world.m_7702_(pos);
    if (te instanceof AnvilTile) {
      AnvilTile anvil = (AnvilTile)te;
      Map<Enchantment, Integer> ench = EnchantmentHelper.m_44831_(stack);
      ench.keySet().removeIf(e -> !m_5456_().canApplyAtEnchantingTable(stack, e));
      anvil.getEnchantments().putAll(ench);
    } 
  }
  
  public List<ItemStack> m_49635_(BlockState state, LootParams.Builder builder) {
    ItemStack anvil = new ItemStack((ItemLike)this);
    Object object = builder.m_287261_(LootContextParams.f_81462_);
    if (object instanceof AnvilTile) {
      AnvilTile te = (AnvilTile)object;
      Object2IntMap object2IntMap = te.getEnchantments();
      Map map = (Map)object2IntMap.entrySet().stream().filter(e -> (((Integer)e.getValue()).intValue() > 0)).collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue));
      EnchantmentHelper.m_44865_(map, anvil);
    } 
    return List.of(anvil);
  }
  
  public ItemStack getCloneItemStack(BlockState state, HitResult target, BlockGetter world, BlockPos pos, Player player) {
    ItemStack anvil = new ItemStack((ItemLike)this);
    BlockEntity te = world.m_7702_(pos);
    if (te instanceof AnvilTile) {
      Object2IntMap object2IntMap = ((AnvilTile)te).getEnchantments();
      Map map = (Map)object2IntMap.entrySet().stream().filter(e -> (((Integer)e.getValue()).intValue() > 0)).collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue));
      EnchantmentHelper.m_44865_(map, anvil);
    } 
    return anvil;
  }
  
  @OnlyIn(Dist.CLIENT)
  public void m_5871_(ItemStack stack, BlockGetter world, List<Component> tooltip, TooltipFlag flagIn) {
    if (!stack.m_41790_())
      tooltip.add(Component.m_237115_("info.apotheosis.anvil").m_130940_(ChatFormatting.GRAY)); 
  }
  
  public void m_6810_(BlockState state, Level world, BlockPos pos, BlockState newState, boolean isMoving) {
    if (!((BlockEntityType)Apoth.Tiles.ANVIL.get()).m_155262_(newState))
      world.m_46747_(pos); 
  }
  
  public void m_213897_(BlockState pState, ServerLevel pLevel, BlockPos pPos, RandomSource pRand) {
    if (m_53241_(pLevel.m_8055_(pPos.m_7495_())) && pPos.m_123342_() >= pLevel.m_141937_()) {
      BlockEntity be = pLevel.m_7702_(pPos);
      FallingBlockEntity e = FallingBlockEntity.m_201971_((Level)pLevel, pPos, pState);
      if (be instanceof AnvilTile) {
        AnvilTile anvil = (AnvilTile)be;
        e.f_31944_ = new CompoundTag();
        anvil.m_183515_(e.f_31944_);
      } 
      m_6788_(e);
    } 
  }
  
  public void m_48792_(Level world, BlockPos pos, BlockState fallState, BlockState hitState, FallingBlockEntity anvil) {
    super.m_48792_(world, pos, fallState, hitState, anvil);
    List<ItemEntity> items = world.m_45976_(ItemEntity.class, new AABB(pos, pos.m_7918_(1, 1, 1)));
    if (anvil.f_31944_ == null)
      return; 
    Map<Enchantment, Integer> enchantments = EnchantmentHelper.m_44882_(anvil.f_31944_.m_128437_("enchantments", 10));
    int oblit = ((Integer)enchantments.getOrDefault(Ench.Enchantments.OBLITERATION.get(), Integer.valueOf(0))).intValue();
    int split = ((Integer)enchantments.getOrDefault(Ench.Enchantments.SPLITTING.get(), Integer.valueOf(0))).intValue();
    int ub = ((Integer)enchantments.getOrDefault(Enchantments.f_44986_, Integer.valueOf(0))).intValue();
    if (split > 0 || oblit > 0)
      for (ItemEntity entity : items) {
        ItemStack stack = entity.m_32055_();
        if (stack.m_41720_() == Items.f_42690_) {
          ListTag enchants = EnchantedBookItem.m_41163_(stack);
          boolean handled = false;
          if (enchants.size() == 1 && oblit > 0) {
            handled = handleObliteration(world, pos, entity, enchants);
          } else if (enchants.size() > 1 && split > 0) {
            handled = handleSplitting(world, pos, entity, enchants);
          } 
          if (handled) {
            if (world.f_46441_.m_188503_(1 + ub) == 0) {
              BlockState dmg = m_48824_(fallState);
              if (dmg == null) {
                world.m_46597_(pos, Blocks.f_50016_.m_49966_());
                world.m_46796_(1029, pos, 0);
                break;
              } 
              world.m_46597_(pos, dmg);
            } 
            break;
          } 
        } 
      }  
  }
  
  protected boolean handleSplitting(Level world, BlockPos pos, ItemEntity entity, ListTag enchants) {
    entity.m_142687_(Entity.RemovalReason.DISCARDED);
    for (Tag nbt : enchants) {
      CompoundTag tag = (CompoundTag)nbt;
      int level = tag.m_128451_("lvl");
      Enchantment enchant = (Enchantment)ForgeRegistries.ENCHANTMENTS.getValue(new ResourceLocation(tag.m_128461_("id")));
      if (enchant == null)
        continue; 
      ItemStack book = EnchantedBookItem.m_41161_(new EnchantmentInstance(enchant, level));
      Block.m_49840_(world, pos.m_7494_(), book);
    } 
    world.m_6443_(ServerPlayer.class, (new AABB(pos)).m_82377_(5.0D, 5.0D, 5.0D), EntitySelector.f_20408_).forEach(p -> AdvancementTriggers.SPLIT_BOOK.trigger(p.m_8960_()));
    return true;
  }
  
  protected boolean handleObliteration(Level world, BlockPos pos, ItemEntity entity, ListTag enchants) {
    CompoundTag nbt = enchants.m_128728_(0);
    int level = nbt.m_128451_("lvl") - 1;
    if (level <= 0)
      return false; 
    Enchantment enchant = (Enchantment)ForgeRegistries.ENCHANTMENTS.getValue(new ResourceLocation(nbt.m_128461_("id")));
    if (enchant == null)
      return false; 
    ItemStack book = EnchantedBookItem.m_41161_(new EnchantmentInstance(enchant, level));
    entity.m_142687_(Entity.RemovalReason.DISCARDED);
    Block.m_49840_(world, pos.m_7494_(), book);
    Block.m_49840_(world, pos.m_7494_(), book.m_41777_());
    return true;
  }
  
  public ItemStack toStack(BlockState state, CompoundTag tag) {
    ItemStack anvil = new ItemStack((ItemLike)this);
    Map<Enchantment, Integer> ench = EnchantmentHelper.m_44882_(tag.m_128437_("enchantments", 10));
    ench = (Map<Enchantment, Integer>)ench.entrySet().stream().filter(e -> (((Integer)e.getValue()).intValue() > 0)).collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue));
    EnchantmentHelper.m_44865_(ench, anvil);
    return anvil;
  }
}
